stages:
  - build
  - docker
  - deploy

variables:
  DOCKER_IMAGE_DEV: $CI_REGISTRY_IMAGE:$CI_COMMIT_BRANCH
  DOCKER_IMAGE_STAGING: $CI_REGISTRY_IMAGE:staging
  DOCKER_IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
  DOCKER_IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

build_ts_app:
  stage: build
  image: node:15.8.0-alpine3.11
  before_script:
    - echo "@joel-muehlena-website:registry=https://gitlab.com/api/v4/packages/npm/" >> .npmrc
    - echo "//gitlab.com/api/v4/packages/npm/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
    - echo " //gitlab.com/api/v4/projects/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
  script:
    - npm i
    - npm run build
  artifacts:
    expire_in: 1 hour
    paths:
      - build

docker:latest:
  stage: docker
  image: docker:latest
  variables:
    DOCKER_HOST: "tcp://docker:2375"
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:20.10.2-dind
  before_script:
    - docker login -u $CI_DOCKER_USER -p $GITLAB_DOCKER_REGKEY $CI_REGISTRY
    - echo "@joel-muehlena-website:registry=https://gitlab.com/api/v4/packages/npm/" >> .npmrc
    - echo "//gitlab.com/api/v4/packages/npm/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
    - echo " //gitlab.com/api/v4/projects/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
  after_script:
    - docker logout
  script:
    #- docker buildx build --platform linux/amd64,linux/arm/v7 --push -t $DOCKER_IMAGE_LATEST .
    - docker build -t $DOCKER_IMAGE_LATEST .
    - docker push $DOCKER_IMAGE_LATEST

docker:tag:
  stage: docker
  image: docker:latest
  variables:
    DOCKER_HOST: "tcp://docker:2375"
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:20.10.2-dind
  before_script:
    - docker login -u $CI_DOCKER_USER -p $GITLAB_DOCKER_REGKEY $CI_REGISTRY
    - echo "@joel-muehlena-website:registry=https://gitlab.com/api/v4/packages/npm/" >> .npmrc
    - echo "//gitlab.com/api/v4/packages/npm/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
    - echo " //gitlab.com/api/v4/projects/:_authToken=${NPM_REGISTRY_TOKEN}" >> .npmrc
  after_script:
    - docker logout
  script:
    #- docker buildx build --platform linux/amd64,linux/arm/v7 --push -t $DOCKER_IMAGE_LATEST .
    - docker build -t $DOCKER_IMAGE_TAG .
    - docker push $DOCKER_IMAGE_TAG
  only:
    - tags
